SystemOrganization addCategory: #LightControlling!

Object subclass: #Bulb
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LightControlling'!

Object subclass: #LightController
	instanceVariableNames: 'mcController sockets powerManagerPath activeProcess startTime stopTime waitTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LightControlling'!

!LightController class methodsFor: 'instance creation' stamp: 'rkrk 2/4/2008 20:12'!
powerManagerPath: aString

	^ self new
		powerManagerPath: aString;
		yourself.! !

!LightController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 20:15'!
activeProcess
	^ activeProcess! !

!LightController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 20:15'!
activeProcess: anObject
	activeProcess := anObject! !

!LightController methodsFor: 'private light control' stamp: 'rkrk 2/4/2008 20:10'!
basicSwitchSocket: socketNumber to: socketState

	sockets at: socketNumber put: socketState! !

!LightController methodsFor: 'public light control' stamp: 'rkrk 2/4/2008 01:32'!
blink
	
	self turnLightsOff.
	
	self greenLightSocketTo: #on.
	(Delay forSeconds: 1) wait.
	self greenLightSocketTo: #off.
	
	self yellowLightSocketTo: #on.
	(Delay forSeconds: 1) wait.
	self yellowLightSocketTo: #off.
	
	self redLightSocketTo: #on.
	(Delay forSeconds: 1) wait.
	self redLightSocketTo: #off.! !

!LightController methodsFor: 'OSProcess control' stamp: 'rkrk 2/6/2008 10:56'!
buildCommandFromSocket: socketNumber state: socketState

	^ self powerManagerPath , 'pm2.exe -' , socketState asString , ' -Device1 -Socket' , socketNumber asString! !

!LightController methodsFor: 'public light control' stamp: 'rkrk 2/6/2008 18:17'!
dance
	
	
	self greenLightSocketTo: #on.
	self redLightSocketTo: #on.
	(Delay forMilliseconds: 600) wait.
	self turnLightsOff.

	self yellowLightSocketTo: #on.
	(Delay forMilliseconds: 400) wait.
	self turnLightsOff.
	
	self redLightSocketTo: #on.
	(Delay forMilliseconds: 100) wait.
	self turnLightsOff.
	self yellowLightSocketTo: #on.
	(Delay forMilliseconds: 100) wait.
	self turnLightsOff.
	self greenLightSocketTo: #on.
	(Delay forMilliseconds: 100) wait.
	self turnLightsOff.
	
	self greenLightSocketTo: #on.
	(Delay forMilliseconds: 50) wait.
	self yellowLightSocketTo: #on.
	(Delay forMilliseconds: 50) wait.
	self redLightSocketTo: #on.
	(Delay forMilliseconds: 50) wait.
	self turnLightsOff.
	
	self redLightSocketTo: #on.
	(Delay forMilliseconds: 20) wait.
	self yellowLightSocketTo: #on.
	(Delay forMilliseconds: 20) wait.
	self greenLightSocketTo: #on.
	(Delay forMilliseconds: 20) wait.
	self turnLightsOff.
	
	self greenLightSocketTo: #on.
	self yellowLightSocketTo: #on.
	self redLightSocketTo: #on.
	(Delay forMilliseconds: 800) wait.
	self turnLightsOff.

	3 timesRepeat: [	
	self greenLightSocketTo: #on.
	self greenLightSocketTo: #off.
	self yellowLightSocketTo: #on.
	self yellowLightSocketTo: #off.
	self redLightSocketTo: #on.
	self redLightSocketTo: #off].

	self greenLightSocketTo: #on.
	self redLightSocketTo: #on.
	self yellowLightSocketTo: #on.

	(Delay forMilliseconds: 600) wait.
	self turnLightsOff.
! !

!LightController methodsFor: 'default' stamp: 'rkrk 2/6/2008 10:54'!
defaultStartTime

	^ Time hour: 8 minute: 0 second: 0! !

!LightController methodsFor: 'default' stamp: 'rkrk 2/6/2008 10:53'!
defaultStopTime

	^ Time hour: 22 minute: 45 second: 0! !

!LightController methodsFor: 'test running' stamp: 'rkrk 2/17/2008 14:48'!
defaultTestCategories

	"Don't do this; run all childs from TestCase instead'"
	^ 'SqueakSVN-Test'! !

!LightController methodsFor: 'default' stamp: 'rkrk 2/6/2008 10:54'!
defaultWaitDuration

	^ Duration minutes: 20.! !

!LightController methodsFor: 'OSProcess control' stamp: 'rkrk 2/11/2008 18:15'!
executeViaOSProcessSynchronously: command

	| p |
	p := ExternalOSProcess command: command.
	[p isComplete] whileFalse: [(Delay forMilliseconds: 100) wait].! !

!LightController methodsFor: 'public light control' stamp: 'rkrk 2/4/2008 01:06'!
greenLightSocketTo: socketState

	self
		switchSocket: 3
		to: socketState.! !

!LightController methodsFor: 'testing' stamp: 'rkrk 2/8/2008 20:32'!
inActiveTime

	(Date today weekday = #Sunday or: [Date today weekday = #Saturday])
		ifTrue: [^ false].
	^ Time now > self startTime
		and: [Time now < self stopTime]! !

!LightController methodsFor: 'initialize-release' stamp: 'rkrk 2/17/2008 14:45'!
initialize

	mcController := MCController new.
	sockets := OrderedCollection with: #off with: #off with: #off.
	self
		stopTime: self defaultStopTime;
		startTime: self defaultStartTime;
		waitTime: self defaultWaitDuration.! !

!LightController methodsFor: 'versionLoading' stamp: 'rkrk 2/4/2008 02:22'!
loadNewestVersions

	mcController loadNewestVersion.! !

!LightController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 20:13'!
powerManagerPath

	^ powerManagerPath! !

!LightController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 20:13'!
powerManagerPath: aString

	powerManagerPath := aString! !

!LightController methodsFor: 'public light control' stamp: 'rkrk 2/4/2008 01:06'!
redLightSocketTo: socketState

	self
		switchSocket: 1
		to: socketState.! !

!LightController methodsFor: 'test running' stamp: 'rkrk 2/11/2008 18:26'!
runTestsAndSetLights

	| result |
	self turnLightsOff.
	result := TestReporter new runCategories: self defaultTestCategories.
	"close some strange files from the testReporter"
	FileStream allSubInstances
		select: [:each | '*\tests\*' match: each asString]
		thenDo: [:each | each close].

	result errors ifNotEmpty: [
		self redLightSocketTo: #on.
		(Delay forMilliseconds: 50) wait.
		self turnLightsOff.
		(Delay forMilliseconds: 20) wait.
		self redLightSocketTo: #on.
		(Delay forMilliseconds: 50) wait.
		self turnLightsOff.
		(Delay forMilliseconds: 20) wait.
		self redLightSocketTo: #on.
		^ self].
	result defects ifNotEmpty: [
		self yellowLightSocketTo: #on.
		(Delay forMilliseconds: 50) wait.
		self turnLightsOff.
		(Delay forMilliseconds: 20) wait.
		self yellowLightSocketTo: #on.
		^ self].
	self greenLightSocketTo: #on.! !

!LightController methodsFor: 'private light control' stamp: 'rkrk 2/4/2008 20:03'!
socket: socketNumber hasState: socketState

	^ (sockets at: socketNumber) = socketState! !

!LightController methodsFor: 'user control' stamp: 'rkrk 2/5/2008 14:29'!
startCycle

	self stopCycle.
	self activeProcess: [
		[self inActiveTime
			ifTrue: [self loadNewestVersions; runTestsAndSetLights]
			ifFalse: [self turnLightsOff].
		(Delay forDuration: self waitTime) wait] repeat] fork.! !

!LightController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 20:16'!
startTime
	^ startTime! !

!LightController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 20:16'!
startTime: anObject
	startTime := anObject! !

!LightController methodsFor: 'user control' stamp: 'rkrk 2/4/2008 20:26'!
stopCycle

	self activeProcess ifNotNilDo: [:process | process terminate]! !

!LightController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 20:16'!
stopTime
	^ stopTime! !

!LightController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 20:16'!
stopTime: anObject
	stopTime := anObject! !

!LightController methodsFor: 'lights' stamp: 'rkrk 2/4/2008 20:03'!
switchSocket: socketNumber to: socketState 

	(self socket: socketNumber hasState: socketState) ifTrue: [^ self].
	self basicSwitchSocket: socketNumber to: socketState.
	self executeViaOSProcessSynchronously: (self buildCommandFromSocket: socketNumber state: socketState).! !

!LightController methodsFor: 'public light control' stamp: 'rkrk 2/4/2008 01:05'!
turnLightsOff

	self
		redLightSocketTo: #off;
		yellowLightSocketTo: #off;	
		greenLightSocketTo: #off.! !

!LightController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 20:24'!
waitTime

	^ waitTime! !

!LightController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 20:30'!
waitTime: aDuration

	waitTime := aDuration.! !

!LightController methodsFor: 'public light control' stamp: 'rkrk 2/4/2008 01:06'!
yellowLightSocketTo: socketState

	self
		switchSocket: 2
		to: socketState.! !

Object subclass: #MCController
	instanceVariableNames: 'repository anOlderVersionName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LightControlling'!

!MCController class methodsFor: 'instance creation' stamp: 'rkrk 2/4/2008 00:52'!
forRepository: aMCRepository 
	
	^ self new
		repository: aMCRepository;
		yourself.! !

!MCController class methodsFor: 'instance creation' stamp: 'rkrk 2/4/2008 01:29'!
forRepository: aMCRepository withOlderVersionName: aString
	
	^ (self forRepository: aMCRepository)
		anOlderVersionName: aString
		yourself.! !

!MCController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 00:58'!
anOlderVersionName
	
	^ anOlderVersionName! !

!MCController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 00:58'!
anOlderVersionName: aString

	anOlderVersionName := aString ! !

!MCController methodsFor: 'default' stamp: 'rkrk 2/4/2008 20:04'!
defaultRepository

	^ MCHttpRepository
		location: 'http://www.swa.hpi.uni-potsdam.de/squeaksource/SVNDiffBrowser'
		user: 'rkrk'
		password: 'squeakIsFun123'! !

!MCController methodsFor: 'default' stamp: 'rkrk 2/4/2008 20:05'!
defaultVersionName

	^  'SqueakSVN-rkrk.19'! !

!MCController methodsFor: 'finding' stamp: 'rkrk 2/4/2008 00:24'!
findNameOfNewesVersionOf: aCollection 
	
	| biggestVersionNumber eachVersionNumber |
	self assert: aCollection isEmpty not.
	^ aCollection inject: aCollection first into: [:biggestVersion :each |
			biggestVersionNumber := (biggestVersion subStrings: '.') last asNumber.
			eachVersionNumber := (each subStrings: '.') last asNumber.
			biggestVersionNumber < eachVersionNumber
				ifTrue: [each]
				ifFalse: [biggestVersion]].! !

!MCController methodsFor: 'finding' stamp: 'rkrk 2/4/2008 20:07'!
initialize

	super initialize.
	self 
		repository: self defaultRepository;
		anOlderVersionName: self defaultVersionName.! !

!MCController methodsFor: 'loading' stamp: 'rkrk 2/4/2008 02:12'!
loadNewestVersion

	| newestVersion newerVersions oldVersionName oldVersionInfo |
	
	oldVersionName := (self repository allFileNamesForVersionNamed: self anOlderVersionName) first.
	oldVersionInfo := (self versionNamed: oldVersionName) info.
	newerVersions := self repository possiblyNewerVersionsOfAnyOf: {oldVersionInfo}.
	newestVersion := self findNameOfNewesVersionOf: newerVersions.
	(self versionNamed: newestVersion , '.mcz') load.! !

!MCController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 00:53'!
repository
	
	^ repository! !

!MCController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 00:53'!
repository: aMCRepository 
	
	repository := aMCRepository! !

!MCController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 00:54'!
versionNamed: aString 
	
	^ self repository versionFromFileNamed: aString.! !

TestCase subclass: #BulbTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LightControlling'!

TestCase subclass: #LightControllerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LightControlling'!

TestCase subclass: #MCControllerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LightControlling'!

!MCControllerTest methodsFor: 'tests' stamp: 'rkrk 2/4/2008 00:10'!
testFindNewesVersionName

	| versionNames versionNameFound sut |
	versionNames := #('SqueakSVN-rkrk.18' 'SqueakSVN-rkrk.19' 'SqueakSVN-rkrk.17' ).
	sut := MCController new.
	versionNameFound := sut findNameOfNewesVersionOf: versionNames.
	self assert: versionNameFound = 'SqueakSVN-rkrk.19'.! !

!MCControllerTest methodsFor: 'tests' stamp: 'rkrk 2/4/2008 00:51'!
testLoadVersionFile

	| repository sut result |
	repository := MCHttpRepository
		location: 'http://www.swa.hpi.uni-potsdam.de/squeaksource/SVNDiffBrowser'
		user: 'rkrk' password: 'squeakIsFun123'.
	sut := MCController forRepository: repository.
	result := sut versionNamed: 'SqueakSVN-rkrk.19.mcz'.
	self assert: result info name =  'SqueakSVN-rkrk.19'! !
